    org 100h    ; code starts at offset 100h
    use16       ; use 16-bit code

main:
    mov dh, 06h         ; divisor for modulo
    mov cl, 013h        ; rows count

loop_y:
    push cx

    mov ah, 02h         ; print
    mov dl, 0Ah         ; new line
    int 21h

    ; modulo, y % 6 -> bl
    mov ax, cx
    div dh
    mov bl, ah

    mov cl, 013h        ; columns count
    loop_x:
        mov dl, ' '

        ; next 2 blocks of asm implement next function:
        ; def check(x:int, y:int) -> bool:
        ;     m = 6
        ;     a = (x  + 3) % m == y % m
        ;     b = (33 - x) % m == y % m
        ;     return a or b
        ;
        ; x and y - corrdinates
        ; returns boolean: True -> draw '*', False -> draw ' '
        ; y % m - already calculated and stored in bl

        mov ax, cx      ; x + 3
        add ax, 03h     ; ^^^^^
        div dh
        mov bh, ah      ; (x  + 3) % m -> bh

        cmp bh, bl
        je draw_star

        mov ax, 023h    ; 35 - x
        sub ax, cx      ; ^^^^^^
        div dh
        mov bh, ah      ; (35 - x) % m -> bh

        cmp bh, bl
        jne skip
    draw_star:
        mov dl, '*'
    skip:

        mov ah, 02h     ; print symbol '*' or ' ', which stored in dl
        int 21h
        loop loop_x

    pop cx
    loop loop_y

    int 20h     ; HLT could be used to save 1 byte
